- include_tasks: get-auth.yaml
- include_role:
    name: commons
    tasks_from: helpers/externalservice.yaml
  vars:
    externalip: "{{ gitea_ssh_external_ip if (gitea_ssh_external_ip | default(False))
                                          else False }}"
    ports: "{{ [ 22 ] if (do_loadbalancer_services | default(False)
                          or gitea_ssh_external_ip | default(False))
                      else [ 2022 ] }}"
    svc_name: "{{ gitea_name }}-external"
    svc_selector: "{{ gitea_name }}"
    svc_target_add: "{{ 2000 if (do_loadbalancer_services | default(False)
                                 or gitea_ssh_external_ip | default(False))
                             else False }}"
    svc_topology_affinity: True
- name: Lookups Gitea Configuration
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: v1
    kind: ConfigMap
    namespace: "{{ namespace }}"
    name: "{{ gitea_name }}"
  no_log: True
  poll: 5
  register: gt_cm
- name: Lookups Gitea External Service
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: v1
    kind: Service
    namespace: "{{ namespace }}"
    name: "{{ gitea_name }}-external"
  no_log: True
  poll: 5
  register: gt_exsvc
  when:
  - do_loadbalancer_services | default(False)
- block:
  - name: Generates Gitea internal token
    register: gitea_internal_token
    shell: tr -d -c "a-z0-9" < /dev/urandom 2>/dev/null | head -c 105
  - name: Generates Gitea secret key
    changed_when: False
    register: gitea_secret_key
    shell: tr -d -c "a-z0-9" < /dev/urandom 2>/dev/null | head -c 10
  - name: Sets Gitea Security Facts
    changed_when: False
    set_fact:
      internal_token: "{{ gitea_internal_token.stdout_lines[0] }}"
      secret_key: "{{ gitea_secret_key.stdout_lines[0] }}"
  when:
  - gt_cm is defined
  - gt_cm.resources is defined
  - gt_cm.resources | length == 0
- block:
  - name: Writes temporary INI file
    changed_when: False
    copy:
      content: |
        [global]
        {{ gt_cm.resources[0].data['app.ini'] }}
      dest: "/tmp/gitea-{{ namespace }}-{{ gitea_name }}"
      mode: 0600
  - name: Sets Gitea Security Facts
    changed_when: False
    set_fact:
      internal_token: "{{ lookup('ini', 'INTERNAL_TOKEN section=security file=/tmp/gitea-' ~ namespace ~ '-' ~ gitea_name) }}"
      secret_key: "{{ lookup('ini', 'SECRET_KEY section=security file=/tmp/gitea-' ~ namespace ~ '-' ~ gitea_name) }}"
  - name: Purges temporary file
    changed_when: False
    file:
      dest: "/tmp/gitea-{{ namespace }}-{{ gitea_name }}"
      state: absent
  when:
  - internal_token is not defined
  - gt_cm is defined
  - gt_cm.resources is defined
- name: Fetches Gitea Database Secret
  async: 30
  changed_when: False
  k8s_info:
    api_version: v1
    kind: Secret
    name: "{{ gitea_pg_name }}"
    namespace: "{{ namespace }}"
  no_log: True
  poll: 5
  register: gitea_db_secret
- name: Install Gitea Configuration
  async: 30
  k8s:
    definition: "{{ lookup('template', 'config.j2') }}"
  poll: 5
  register: gt_cf
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ gitea_name }}-external"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ gitea_name }}"
    to:
    - number: "2022"
